program MHD;
uses crtp2,Dos;

const N = 60; (*pocet stanic*)
      L = 4;  (*pocet linek*)
      M = 10; (*maximalni pocet intervalu na lince*)
      P = 21; (*maximalni pocet cest ze zastavky do zastavky na jedne lince*)
      maxrychchuze = 30; (*maximalni pripustna rychlost chuze uzivatele v m/s*)

label zacatek;
type zasst = record   (*pro zasobnik*)
           cislozast:1..N;
           cislolinky:1..L+1;
           aktcas:word;
           pesky:word;
           end;
     intervzasob = 0..2*(L+1)*N;
     intervlinky = 0..L+1;
     intervstanic = 0..N;

var casy: array[1..N,1..N] of byte;(*doba jizdy ze stanice sour. x do stanice v sour. y*)
    zasobnik: array[1..2*(L+1)*N] of zasst;
    stanpole: array[1..N,1..L] of boolean;
    (*ulozeno zda v dane stanici jezdi ta ktera linka*)
    aktcasy: array[1..N,1..L+1,0..9*L,1..2] of word;
    (*ukladaji se prozatim zjistene nejkratsi casy kterymi se muze dospet do zastavek*)
    cislozast,aktzastavka:intervstanic;
    start,cil,ulozcil:intervstanic;
    aktlinka:intervlinky;
    peskycelkem,aktcas,stop,dobajizdy,i,j,maxpesky,ulozmaxpesky,casnast: word;
    maxzasindex,zasindex: intervzasob; (*aktualni index v zasobniku *)
    intervalpole: array[1..L,1..M,1..2] of word;
    spoje: array[1..L,1..P,1..2] of word;
    pesky: array[1..N,1..N] of word;
    zpetnychod: array[1..N,1..L+1,1..5] of word;
    rychl:real;
    poprve:boolean; (*pro spocticas, aby se index i neukladal pri rekurzivnim volani*)
    prvnii:byte; (*pro spocticas*)
    jezdi:boolean; (*pro spocticas, jestli by nebyla nekonecna rekurze,
                     pokud by linka vubec nejezdila (vsechny intervaly = 0*)
    ProgMode,OrigMode:integer; (*ulozi puvodni nastaveni obrazovky*)
    treticast,konec: boolean;
    o,zast,posllinka:word;
    cesta: array[1..N,1..4] of word;

procedure inicializace;
   var i,j,k:integer;
   begin
   treticast := FALSE;
   konec := false;
   poprve := TRUE;
   jezdi := TRUE;
   stop := maxint;
   for i := 1 to N do
       begin
          for j := 1 to N do
            begin casy[i,j] := 0 end;
          for j :=1 to L do
          begin
          stanpole[i,j] := false;
          end;
          for j:=1 to L+1 do
              begin
              aktcasy[i,j,0,1] := 0;
              for k := 1 to L do
                  begin
                  aktcasy[i,j,k,1] := maxint;
                  aktcasy[i,j,k,2] := maxint;
                  end;
              zpetnychod[i,j,1] := 0;
              zpetnychod[i,j,2] := 0;
              end;
       end;
   for i := 1 to L do
       begin
            for j := 1 to P do
                begin
                     spoje[i,j,1] := 0; spoje[i,j,2] := 0;
                end;
       end;
   end;

procedure inicializace2;
   var i,j,k:integer;
   begin
   konec := false;
   poprve := TRUE;
   jezdi := TRUE;
   for i := 1 to N do
       begin
          for j:=1 to L+1 do
              begin
              aktcasy[i,j,0,1] := 0;
              for k := 1 to L do
                  begin
                  aktcasy[i,j,k,1] := maxint;
                  aktcasy[i,j,k,2] := maxint;
                  end;
              zpetnychod[i,j,1] := 0;
              zpetnychod[i,j,2] := 0;
              end;
       end;
   end;

procedure nactenidat;
   var x,a,b,i,linka:integer;
       linky, interval: text;
   begin
   assign(linky, 'data\linky.txt');
   reset(linky);

   while not seekeof(linky) do
   begin
      read(linky, x);
      if x = 0 then begin read(linky, linka); i := 0; end;
      if x <> 0 then begin read(linky, a); read(linky, b);
                        i := i + 1;
                        spoje[linka,i,1] := x; spoje[linka,i,2] := a;
                        stanpole[x,linka] := true; stanpole[a,linka] := true;
                        casy[x,a] := b;
                        casy[a,x] := b;
                     end;
   end;
   close(linky);

   assign(interval, 'data\interval.txt');
   reset(interval);
   while not seekeof(interval) do
     begin
     read(interval, x);
     if x = -1 then begin read(interval, linka); i := 1; end;
     if x <> -1 then begin
                    read(interval, a); read(interval, b);
                    intervalpole[linka,i,1] := 60*x+a;
                    intervalpole[linka,i,2] := b;
                    i := i + 1;
                    end;
     end;
   close(interval);
   end;

procedure nactenisour;
   var x,a,b,i,j:integer;
       pole: array[1..N,1..2] of integer;
       sourad: text;
   begin
       assign(sourad, 'data\sourad.txt');
       reset(sourad);
       repeat
         begin
         read(sourad, x); read(sourad, a); read(sourad, b);
         pole[x,1] := a; pole[x,2] :=b;
         end;
       until seekeof(sourad);
       for i := 1 to N do
           begin
             for j := i to N do
                 begin
                 pesky[i,j] := Round(((sqrt(sqr(pole[i,1] - pole[j,1]) + sqr(pole[i,2] - pole[j,2])))/(rychl))*6);
                 pesky[j,i] := pesky[i,j];
                 end;
           end;
   end;

function spocticas(linka:integer; aktcas:integer): integer;
    var doba,cas,i,celkem:integer;
    begin
    doba := aktcas mod 1440;
    i := 1;
    while intervalpole[linka,i,1] <= doba do i := i + 1;
    cas := intervalpole[linka, i-1, 2];
    if poprve then begin prvnii := i; poprve := FALSE; end
              else begin if prvnii = i then jezdi := FALSE; end;
    if (cas = 0) AND jezdi
       then
          begin
          celkem := intervalpole[linka, i, 1] - doba;
          spocticas := celkem + spocticas(linka,intervalpole[linka, i, 1]);
          end
       else spocticas := cas;
    end;

function pokracovat(cislozast:intervstanic;linka:intervlinky;spocitanycas:word;peskycelkem:word): boolean;
   var i:word;
   begin
   pokracovat := TRUE;
   for i := 1 to aktcasy[cislozast,linka,0,1] do
       begin
        if (spocitanycas >= aktcasy[cislozast,linka,i,1]) AND
           (peskycelkem >= aktcasy[cislozast,linka,i,2]) then
           begin pokracovat := FALSE; Break; end;

       end;
   end;

procedure dozasob(var zasindex:intervzasob; cislozast:intervstanic;
                  aktlinka:intervlinky; aktcas:word; aktzastavka:intervstanic;peskycelkem:word);
    var aktcasted,i,spocitanycas:word;
    begin
    if aktlinka = L+1 then begin
                           aktcasted := aktcas + pesky[aktzastavka,cislozast];
                           peskycelkem := peskycelkem + pesky[aktzastavka,cislozast];
                           end
                      else aktcasted := aktcas + casy[aktzastavka,cislozast];
    for i := 1 to L do
       begin
       if stanpole[cislozast,i] then
          begin
          if i <> aktlinka then spocitanycas := (aktcasted + spocticas(i,aktcas))
                           else spocitanycas := aktcasted;
          if jezdi then
             begin
             poprve := TRUE;
             if (peskycelkem <= maxpesky) and pokracovat(cislozast,i,spocitanycas,peskycelkem)
                then
                begin
                zasindex := zasindex + 1;
                zasobnik[zasindex].cislozast := cislozast;
                zasobnik[zasindex].cislolinky := i;
                zasobnik[zasindex].pesky := peskycelkem;
                zasobnik[zasindex].aktcas := spocitanycas;
                aktcasy[cislozast,i,0,1] := aktcasy[cislozast,i,0,1] + 1;
                aktcasy[cislozast,i,aktcasy[cislozast,i,0,1],1] := spocitanycas;
                aktcasy[cislozast,i,aktcasy[cislozast,i,0,1],2] := peskycelkem;
                zpetnychod[cislozast,i,1] := aktzastavka;
                zpetnychod[cislozast,i,2] := aktlinka;
                zpetnychod[cislozast,i,3] := aktlinka;
                zpetnychod[cislozast,i,4] := aktcas;
                zpetnychod[cislozast,i,5] := aktcasted;
                if not treticast
                   then
                      begin
                      if (cislozast = cil) and (stop > spocitanycas) then
                         begin stop := spocitanycas; posllinka := i; end;
                      end
                   else
                      begin
                      if (cislozast = cil) and (stop = spocitanycas)
                         and ((aktlinka = i) <= ((i = posllinka) or (posllinka=L+1))) then
                                           begin

                                           posllinka := i; konec := true; Exit;
                                           end;
                      end;
                end;
             end
             else begin jezdi := true; poprve := true; end;
          end;
       end;
    end;

procedure dozasob2(var zasindex:intervzasob; cislozast:intervstanic;
                   aktlinka:intervlinky; aktcas:word; aktzastavka:intervstanic; peskycelkem:word);
    var aktcasted,peskyted:word;
    begin
    aktcasted := (aktcas + pesky[cislozast,aktzastavka]);
    peskyted := (pesky[cislozast,aktzastavka] + peskycelkem);
    if pokracovat(cislozast,L+1,aktcasted,peskyted) AND (peskyted <= maxpesky) then
       begin
       aktcasy[cislozast,L+1,0,1] := aktcasy[cislozast,L+1,0,1] + 1;
       aktcasy[cislozast,L+1,aktcasy[cislozast,L+1,0,1],1] := aktcasted;
       aktcasy[cislozast,L+1,aktcasy[cislozast,L+1,0,1],2] := peskyted;
       zasindex := zasindex + 1;
       zasobnik[zasindex].cislozast := cislozast;
       zasobnik[zasindex].cislolinky := L+1;
       zasobnik[zasindex].aktcas := aktcasted;
       zasobnik[zasindex].pesky := peskyted;
       zpetnychod[cislozast,L+1,1] := aktzastavka;
       zpetnychod[cislozast,L+1,2] := aktlinka;
       zpetnychod[cislozast,L+1,3] := L+1;
       zpetnychod[cislozast,L+1,4] := aktcas;
       zpetnychod[cislozast,L+1,5] := aktcasted;

       if not treticast
                   then
                      begin
                      if (cislozast = cil) and (stop > aktcasted) then
                         begin stop := aktcasted; posllinka := i; end;
                      end
                   else
                      begin
                      if (cislozast = cil) and (stop = aktcasted)
                         then begin posllinka := L+1; konec := true; Exit; end;
                      end;
       end;
    end;

function existspoj(aktlinka:integer; zast1:integer; zast2:integer): boolean;
   var i:integer;
   begin
     existspoj := FALSE;
     for i := 1 to P do
         begin
         if ((spoje[aktlinka, i, 1] = zast1) AND (spoje[aktlinka, i, 2] = zast2))
            OR ((spoje[aktlinka, i, 1] = zast2) AND (spoje[aktlinka, i, 2] = zast1)) then
            begin existspoj := TRUE; Break; end
         end;
   end;

function pridejnulu(w:Word):string;
var s:string;
begin
  Str(w:0,s);
  if Length(s) = 1 then
    s := '0' + s;
  pridejnulu := s;

end;


procedure vypiscestu(i:word);
   var s,j,cekani,stranka:integer;
   begin
   ClrScr;
   writeln('Ze zastvky slo ',start,':');
   stranka := Hi(Windmax) - Hi(Windmin);
   s := 1;
   for j := i-1 downto 1 do
       begin
       if cesta[j,1] <> L+1 then
          begin
            cekani := cesta[j,3] - cesta[j+1,4];
            if cekani = 0 then write('                ') else write('ekn ',cekani:3,' min. ');
            writeln('Linkou . ',cesta[j,1]:2,' do zast. ',cesta[j,2]:3,
                    ', odjezd ',pridejnulu((cesta[j,3] div 60) mod 24),':',pridejnulu(cesta[j,3] mod 60),
                    ', pjezd ',pridejnulu((cesta[j,4] div 60) mod 24),':',pridejnulu(cesta[j,4] mod 60));
          end
         else
          begin
            writeln('                Pky        do zast. ',cesta[j,2]:3,', odchod ',
                    pridejnulu((cesta[j,3] div 60) mod 24),':',pridejnulu(cesta[j,3] mod 60),
                    ', pchod ',pridejnulu((cesta[j,4] div 60) mod 24),':',pridejnulu(cesta[j,4] mod 60));
          end;
       s := s + 1;
       if s = stranka then
          begin
               s := 0;
               write('Stisknte klvesu...');
               Readkey; writeln; writeln;
          end;
       end;
   writeln; writeln('Celkov as cesty: ',(dobajizdy div 60):2,' hod ',(dobajizdy mod 60):2,' min.');
   Readkey;
   end;

procedure vypiscestusoubor(i:word);
   var s,j,cekani,stranka:integer;
       ch:char;
       vysledky:text;
       cestasoubor:Pathstr;
   begin
   writeln;
   writeln('Zapsat tuto cesu do souboru? (A/N)');
   repeat ch := Readkey until (ch = 'A') OR (ch = 'N') OR (ch = 'a') OR (ch = 'n');
   if (ch = 'A') OR (ch = 'a') then
   begin
   Assign(vysledky,'vysledky\vysledky.txt');
   cestasoubor := FSearch('vysledky.txt','vysledky');
   if cestasoubor <> '' then
      begin
         writeln('Soubor vsledk ji existuje, chcete k nmu toto hledn pipojit? (A/N)');
         writeln('   - pokud zvolte nepipojit, bude pepsn!');
         repeat ch := Readkey until (ch = 'A') OR (ch = 'N') OR (ch = 'a') OR (ch = 'n');
         if (ch = 'A') OR (ch = 'a') then Append(vysledky) else Rewrite(vysledky);
      end
     else Rewrite(vysledky);
   writeln(vysledky,'Nstupn zastvka: ',start,'       Vstupn zastvka: ',ulozcil);
   writeln(vysledky,'Rychlost chze: ',rychl:2:2,' m/s    Maximln pky: ',ulozmaxpesky,' minut');
   writeln(vysledky);
   writeln(vysledky,'Ze zastvky slo ',start,':');
   for j := i-1 downto 1 do
       begin
       if cesta[j,1] <> L+1 then
          begin
            cekani := cesta[j,3] - cesta[j+1,4];
            if cekani = 0 then write(vysledky,'                ') else write(vysledky,'ekn ',cekani:3,' min. ');
            writeln(vysledky,'Linkou . ',cesta[j,1]:2,' do zast. ',cesta[j,2]:3,
                    ', odjezd ',pridejnulu((cesta[j,3] div 60) mod 24),':',pridejnulu(cesta[j,3] mod 60),
                    ', pjezd ',pridejnulu((cesta[j,4] div 60) mod 24),':',pridejnulu(cesta[j,4] mod 60));
          end
         else
          begin
            writeln(vysledky,'                Pky        do zast. ',cesta[j,2]:3,', odchod ',
                    pridejnulu((cesta[j,3] div 60) mod 24),':',pridejnulu(cesta[j,3] mod 60),
                    ', pchod ',pridejnulu((cesta[j,4] div 60) mod 24),':',pridejnulu(cesta[j,4] mod 60));
          end;
       end;
   writeln(vysledky,''); writeln(vysledky,'Celkov as cesty: ',(dobajizdy div 60):2,' hod ',(dobajizdy mod 60):2,' min.');
   writeln(vysledky,'----------------------------------------------------------------------'); writeln(vysledky,'');
   Close(vysledky);
   writeln;
   writeln('Cesta zapsna do souboru VYSLEDKY.TXT v adresi VYSLEDKY.');
   end;
   end;

Procedure uvod;
   var i,sirka, vyska:byte;
   begin
   Textbackground(0);
   clrscr;
   Textbackground(1);
   sirka := Lo(Windmax) + 1;
   vyska := Hi(Windmax) + 1;
   textcolor(yellow);
   window((sirka-46) div 2, (vyska-9) div 2, sirka,vyska);
   writeln('ͻ');
   writeln('                                            ');
   writeln('           Spoje MHD verze 1.0              ');
   writeln('    Naprogramovno v Turbo Pascalu v 7.0    ');
   writeln('                                            ');
   writeln('    Zpotov program pro prvn semestr     ');
   writeln('        studia MFF obor informatika         ');
   writeln('                                            ');
   writeln('ͼ');
   Textbackground(black);
   Textcolor(black);
   window(1,1,sirka,vyska);
   GotoXY(sirka-2,vyska);
   Write(' ');
   GotoXY(sirka-2,vyska);
       for i := 1 to 10 do
       begin
       delay(150);
       sound(i*100);
       if Keypressed then  Break;
       end;
   Nosound;
   Readkey;
   TextColor(white);
   end;


procedure chybacislozast(sirka,vyska:byte);
     var puvtext:byte;
         puvWindMin,puvWindMax:word;
     begin
     PuvText := textattr;
     puvWindMin := WindMin; puvWindMax := WindMax;
     window((sirka div 2) - 28,vyska div 2,sirka,vyska div 2);
     TextBackground(red); Textcolor(black);
     write('slo zastvky me bt jen pirozen slo od 1 do ',N,'!');
     Sound(500); Delay(20); NoSound;
     window(Lo(puvWindMin)+1,Hi(puvWindMin)+1,Lo(puvWindMax)+1,Hi(puvWindMax)+1);
     TextAttr := Puvtext;
     repeat until KeyPressed;
     window((sirka div 2) - 28,vyska div 2,sirka,vyska div 2);
     TextBackground(black); Clrscr;
     window(Lo(puvWindMin)+1,Hi(puvWindMin)+1,Lo(puvWindMax)+1,Hi(puvWindMax)+1);
     TextAttr := Puvtext;
     ClrScr;
     end;

procedure chybachuze(sirka,vyska:byte);
     var puvtext:byte;
         puvWindMin,puvWindMax:word;
     begin
     PuvText := textattr;
     puvWindMin := WindMin; puvWindMax := WindMax;
     window((sirka div 2) - 31,vyska div 2,sirka,vyska div 2);
     TextBackground(red); Textcolor(black);
     write('Rychlost chze me bt jen kladn reln slo men ne ',maxrychchuze,'!');
     Sound(500); Delay(20); NoSound;
     window(Lo(puvWindMin)+1,Hi(puvWindMin)+1,Lo(puvWindMax)+1,Hi(puvWindMax)+1);
     TextAttr := Puvtext;
     repeat until KeyPressed;
     window((sirka div 2) - 31,vyska div 2,sirka,vyska div 2);
     TextBackground(black); Clrscr;
     window(Lo(puvWindMin)+1,Hi(puvWindMin)+1,Lo(puvWindMax)+1,Hi(puvWindMax)+1);
     TextAttr := Puvtext;
     ClrScr;
     end;

procedure chybapesky(sirka,vyska:byte);
     var puvtext:byte;
         puvWindMin,puvWindMax:word;
     begin
     PuvText := textattr;
     puvWindMin := WindMin; puvWindMax := WindMax;
     window((sirka div 2) - 33,vyska div 2,sirka,vyska div 2);
     TextBackground(red); Textcolor(black);
     write('as maximln doby chze me bt jen cel nezporn slo do 999!');
     Sound(500); Delay(20); NoSound;
     window(Lo(puvWindMin)+1,Hi(puvWindMin)+1,Lo(puvWindMax)+1,Hi(puvWindMax)+1);
     TextAttr := Puvtext;
     repeat until KeyPressed;
     window((sirka div 2) - 33,vyska div 2,sirka,vyska div 2);
     TextBackground(black); Clrscr;
     window(Lo(puvWindMin)+1,Hi(puvWindMin)+1,Lo(puvWindMax)+1,Hi(puvWindMax)+1);
     TextAttr := Puvtext;
     ClrScr;
     end;

procedure chybahod(sirka,vyska:byte);
     var puvtext:byte;
         puvWindMin,puvWindMax:word;
     begin
     PuvText := textattr;
     puvWindMin := WindMin; puvWindMax := WindMax;
     window((sirka div 2) - 22,vyska div 2,sirka,vyska div 2);
     TextBackground(red); Textcolor(black);
     write('Hodina sm bt jen cel slo od 0 do 23!');
     Sound(500); Delay(20); NoSound;
     window(Lo(puvWindMin)+1,Hi(puvWindMin)+1,Lo(puvWindMax)+1,Hi(puvWindMax)+1);
     TextAttr := Puvtext;
     repeat until KeyPressed;
     window((sirka div 2) - 22,vyska div 2,sirka,vyska div 2);
     TextBackground(black); Clrscr;
     window(Lo(puvWindMin)+1,Hi(puvWindMin)+1,Lo(puvWindMax)+1,Hi(puvWindMax)+1);
     TextAttr := Puvtext;
     ClrScr;
     end;

procedure chybamin(sirka,vyska:byte);
     var puvtext:byte;
         puvWindMin,puvWindMax:word;
     begin
     PuvText := textattr;
     puvWindMin := WindMin; puvWindMax := WindMax;
     window((sirka div 2) - 22,vyska div 2,sirka,vyska div 2);
     TextBackground(red); Textcolor(black);
     write('Minuty sm bt jen cel slo od 0 do 59!');
     Sound(500); Delay(20); NoSound;
     window(Lo(puvWindMin)+1,Hi(puvWindMin)+1,Lo(puvWindMax)+1,Hi(puvWindMax)+1);
     TextAttr := Puvtext;
     repeat until KeyPressed;
     window((sirka div 2) - 22,vyska div 2,sirka,vyska div 2);
     TextBackground(black); Clrscr;
     window(Lo(puvWindMin)+1,Hi(puvWindMin)+1,Lo(puvWindMax)+1,Hi(puvWindMax)+1);
     TextAttr := Puvtext;
     ClrScr;
     end;

procedure zadavani;
   var nastX,nastY,vystX,vystY,chuzeX,chuzeY,hodX,hodY,minX,minY,peskyX,peskyY:byte;
       pocdesmist,i,sirka,vyska,volnoY:byte;
       pomocna:word;(*pomocna promenna, aby nepretekl start nebo cil*)
       hodnast,minnast:word;
       ch:char;
       bylacarka: boolean;
       znaky: array[1..5] of char;
   label znovunast, znovuvyst, znovuchuze, znovupesky, znovuhod, znovumin;
   begin
   Textbackground(black);
   Clrscr;
   sirka := Lo(Windmax) + 1;
   vyska := Hi(Windmax) + 1;
   write(''); for i := 3 to sirka do write(''); write('');
   write(''); Write(' Nstupn zastvka: '); nastX := WhereX; nastY := WhereY;
   GotoXY(sirka div 2, WhereY); Write('Vstupn zastvka: '); vystX := WhereX; vystY := WhereY;
   GotoXY(sirka, WhereY); write(' Vae rychlost chze: '); chuzeX := WhereX; chuzeY := WhereY;
   write('       m/s'); GotoXY(sirka div 2, WhereY); Write('as nstupu: '); hodX := WhereX; hodY := WhereY;
   write('   :'); minX := WhereX; minY := WhereY; write('    hodin.');
   GotoXY(sirka, WhereY); write(' Maximln jste ochoten jt pky '); peskyX := WhereX; peskyY := WhereY;
   write('    minut.'); GotoXY(sirka, WhereY); write('');for i := 3 to sirka do write(''); write('');
   volnoY := WhereY;
   Textbackground(blue);
(*cast zadavani nastupni zastavky*)
   Window(nastX,nastY,NastX+4,nastY); Clrscr;
   znovunast:
   for i := 1 to 4 do znaky[i] := ' ';
   for i := 1 to 4 do
         begin
         znaky[i] := Readkey; write(znaky[i]);
         if (ord(znaky[i]) = 13) then Break;
         if (znaky[i] < '0') OR (znaky[i] > '9') then
                      begin chybacislozast(sirka,vyska);
                            Goto znovunast; end;
         end;
   if (znaky[1] < '0') OR (znaky[1] > '9') then begin chybacislozast(sirka,vyska); Goto znovunast; end;
   pomocna := 0;
   for i := 1 to 4 do
         begin
         if not ((znaky[i]=' ') OR (ord(znaky[i]) = 13)) then
            pomocna := (ord(znaky[i]) - ord('0')) + pomocna*10
            else Break;
         end;
   if (pomocna < 1) OR (pomocna > N) then begin chybacislozast(sirka,vyska); Goto znovunast; end;
   start := pomocna;
(*cast zadavani vystupni zastavky*)
   Window(vystX,vystY,vystX+4,vystY); Clrscr;
   znovuvyst:
   for i := 1 to 4 do znaky[i] := ' ';
   for i := 1 to 4 do
         begin
         znaky[i] := Readkey; write(znaky[i]);
         if (ord(znaky[i]) = 13) then Break;
         if (znaky[i] < '0') OR (znaky[i] > '9') then
                      begin chybacislozast(sirka,vyska);
                            Goto znovuvyst; end;
         end;
   if (znaky[1] < '0') OR (znaky[1] > '9') then begin chybacislozast(sirka,vyska); Goto znovuvyst; end;
   pomocna := 0;
   for i := 1 to 4 do
         begin
         if not ((znaky[i]=' ') OR (ord(znaky[i]) = 13)) then
            pomocna := (ord(znaky[i]) - ord('0')) + pomocna*10
            else Break;
         end;
   if (pomocna < 1) OR (pomocna > N) then begin chybacislozast(sirka,vyska); Goto znovuvyst; end;
   cil := pomocna;
(*zadvn rychlosti chuze*)
   Window(chuzeX,chuzeY,chuzeX+6,chuzeY); Clrscr;
   znovuchuze:
   for i := 1 to 5 do znaky[i] := ' ';
   for i := 1 to 5 do
         begin
         znaky[i] := Readkey; write(znaky[i]);
         if (ord(znaky[i]) = 13) then Break;
         if ((znaky[i] < '0') OR (znaky[i] > '9')) AND (znaky[i] <> ',') AND (znaky[i] <> '.') then
                      begin chybachuze(sirka,vyska);
                            Goto znovuchuze; end;
         end;
   if (znaky[1] < '0') OR (znaky[1] > '9') then begin chybachuze(sirka,vyska); Goto znovuchuze; end;
   rychl := 0;
   pocdesmist := 1;
   bylacarka := FALSE;
   for i := 1 to 5 do
         begin
         if not ((znaky[i]=' ') OR (ord(znaky[i]) = 13)) then
              begin
                if (znaky[i] = ',') OR (znaky[i] = '.') then bylacarka := TRUE
                else
                   begin
                     if bylacarka then
                       begin
                       rychl := rychl + ((ord(znaky[i]) - ord('0'))/(exp(pocdesmist*ln(10))));
                       pocdesmist := pocdesmist + 1;
                       end
                     else
                       rychl := rychl*10 + (ord(znaky[i]) - ord('0'))
                   end;
              end
            else Break;
         end;
   if (rychl <= 0) OR (rychl > maxrychchuze) then begin chybachuze(sirka,vyska); Goto znovuchuze; end;
(*zdavani maximalniho casu chuze*)
   Window(peskyX,peskyY,peskyX+3,peskyY); Clrscr;
   znovupesky:
   for i := 1 to 3 do znaky[i] := ' ';
   for i := 1 to 3 do
         begin
         znaky[i] := Readkey; write(znaky[i]);
         if (ord(znaky[i]) = 13) then Break;
         if (znaky[i] < '0') OR (znaky[i] > '9') then
                      begin chybapesky(sirka,vyska);
                            Goto znovupesky; end;
         end;
   if (znaky[1] < '0') OR (znaky[1] > '9') then begin chybapesky(sirka,vyska); Goto znovupesky; end;
   maxpesky := 0;
   for i := 1 to 3 do
         begin
         if not ((znaky[i]=' ') OR (ord(znaky[i]) = 13)) then
            maxpesky := maxpesky*10 + (ord(znaky[i]) - ord('0'))
            else Break;
         end;
   if (maxpesky < 0) OR (maxpesky > 999) then begin chybapesky(sirka,vyska); Goto znovupesky; end;
(*zadavani hodiny nastupu*)
   Window(hodX,hodY,hodX+2,hodY); Clrscr;
   znovuhod:
   for i := 1 to 2 do znaky[i] := ' ';
   for i := 1 to 2 do
         begin
         znaky[i] := Readkey; write(znaky[i]);
         if (ord(znaky[i]) = 13) then Break;
         if (znaky[i] < '0') OR (znaky[i] > '9') then
                      begin chybahod(sirka,vyska);
                            Goto znovuhod; end;
         end;
   if (znaky[1] < '0') OR (znaky[1] > '9') then begin chybahod(sirka,vyska); Goto znovuhod; end;
   hodnast := 0;
   for i := 1 to 2 do
         begin
         if not ((znaky[i]=' ') OR (ord(znaky[i]) = 13)) then
            hodnast := hodnast*10 + (ord(znaky[i]) - ord('0'))
            else Break;
         end;
   if (hodnast < 0) OR (hodnast > 23) then begin chybahod(sirka,vyska); Goto znovuhod; end;
(*zadavani minut nastupu*)
   Window(minX,minY,minX+2,minY); Clrscr;
   znovumin:
   for i := 1 to 2 do znaky[i] := ' ';
   for i := 1 to 2 do
         begin
         znaky[i] := Readkey; write(znaky[i]);
         if (ord(znaky[i]) = 13) then Break;
         if (znaky[i] < '0') OR (znaky[i] > '9') then
                      begin chybamin(sirka,vyska);
                            Goto znovumin; end;
         end;
   if (znaky[1] < '0') OR (znaky[1] > '9') then begin chybamin(sirka,vyska); Goto znovumin; end;
   minnast := 0;
   for i := 1 to 2 do
         begin
         if not ((znaky[i]=' ') OR (ord(znaky[i]) = 13)) then
            minnast := minnast*10 + (ord(znaky[i]) - ord('0'))
            else Break;
         end;
   if (minnast < 0) OR (minnast > 59) then begin chybamin(sirka,vyska); Goto znovumin; end;

   casnast := hodnast*60 + minnast;
   window(1,volnoY,sirka,vyska);
   Textbackground(black);
   end;

procedure cestaneni(sirka,vyska:byte);
     var puvtext:byte;
         puvWindMin,puvWindMax:word;
     begin
     ClrScr;
     PuvText := textattr;
     puvWindMin := WindMin; puvWindMax := WindMax;
     window((sirka div 2) - 20,vyska div 2,sirka,vyska div 2);
     TextBackground(red); Textcolor(black);
     write('Cesta podle vaich poadavk neexistuje!');
     Sound(500); Delay(20); NoSound;
     window(Lo(puvWindMin)+1,Hi(puvWindMin)+1,Lo(puvWindMax)+1,Hi(puvWindMax)+1);
     TextAttr := Puvtext;
     ReadKey;
     window((sirka div 2) - 20,vyska div 2,sirka,vyska div 2);
     TextBackground(black); Clrscr;
     window(Lo(puvWindMin)+1,Hi(puvWindMin)+1,Lo(puvWindMax)+1,Hi(puvWindMax)+1);
     TextAttr := Puvtext;
     ClrScr;
     end;

procedure rozliseni(sirka,vyska:byte);
     var puvtext:byte;
         puvWindMin,puvWindMax:word;
         ch:char;
     begin
     ClrScr;
     PuvText := textattr;
     puvWindMin := WindMin; puvWindMax := WindMax;
     window((sirka div 2) - 26,vyska div 2 - 4,sirka,vyska div 2 + 4);
     TextBackground(blue); Textcolor(yellow);
     writeln('                                                   ');
     writeln('                Vyberte rozlien:                 ');
     writeln('                                                   ');
     writeln('                1)  80 sl. / 25 .                 ');
     writeln(' (Vt psmo, zobraz se najednou mn informac) ');
     writeln('                                                   ');
     writeln('                2)  80 sl. / 50 .                 ');
     writeln('           (Men psmo, je he vidt)            ');
       write('                                                   ');
     window(Lo(puvWindMin)+1,Hi(puvWindMin)+1,Lo(puvWindMax)+1,Hi(puvWindMax)+1);
     repeat ch := ReadKey; until (ch = '1') OR (ch = '2');
     TextBackground(black); Clrscr;
     TextAttr := Puvtext;
     if ch = '1' then Textmode(CO80) else Textmode(CO80 + Font8x8);
     ProgMode := LastMode;
     end;

function ukoncit(sirka,vyska:byte): boolean;
     var puvtext:byte;
         puvWindMin,puvWindMax:word;
         ch:char;
     begin
     PuvText := textattr;
     puvWindMin := WindMin; puvWindMax := WindMax;
     window((sirka div 2) - 19,vyska div 2 - 1,sirka,vyska div 2 + 1);
     TextBackground(blue); Textcolor(yellow);
     writeln('                                     ');
     writeln('  Pokraovat dalm hlednm? (A/N)  ');
       write('                                     ');
     window(Lo(puvWindMin)+1,Hi(puvWindMin)+1,Lo(puvWindMax)+1,Hi(puvWindMax)+1);
     repeat ch := ReadKey; until (ch = 'A') OR (ch = 'N') OR (ch = 'a') OR (ch = 'n');
     TextBackground(black); Clrscr;
     TextAttr := Puvtext;
     if (ch = 'A') OR (ch = 'a') then ukoncit := FALSE else ukoncit := TRUE;
     end;

begin (*of program*)
   {$B-}
   OrigMode := LastMode;
   uvod;
   rozliseni(Lo(WindMax)+1,Hi(Windmax)+1);
   inicializace;
   nactenidat;
zacatek:
   inicializace2;
   stop := maxint;
   treticast := FALSE;
   TextMode(ProgMode);
   zadavani;
   nactenisour;
   writeln; writeln('Vyhledvm cestu...');
   (*prvni cast - vyhledani cesty bez pesiho chozeni*)
   aktcas := 0;
   aktlinka := 0;
   zasindex := 0;
   dozasob(zasindex,start,aktlinka,casnast,start,0);
   if zasindex > 0 then
  begin
   repeat
         begin
              aktzastavka := zasobnik[zasindex].cislozast;
              aktlinka := zasobnik[zasindex].cislolinky;
              aktcas := zasobnik[zasindex].aktcas;
              zasindex := zasindex - 1;
             for i := 1 to N do
             begin
              if (aktcas <= stop) AND existspoj(aktlinka,aktzastavka,i)
              then
                 begin
                 dozasob(zasindex,i,aktlinka,aktcas,aktzastavka,0);
                 end;
             end;
         end;
   until zasindex = 0;
  end;
   (*konec prvni casti*)
   inicializace2;
   (*druha cast - i pesky*)
   aktcas := 0;
   aktlinka := 0;
   zasindex := 0;
   dozasob(zasindex,start,aktlinka,casnast,start,0);
   dozasob2(zasindex,start,aktlinka,casnast,start,0);
   repeat
         begin
              aktzastavka := zasobnik[zasindex].cislozast;
              aktlinka := zasobnik[zasindex].cislolinky;
              aktcas := zasobnik[zasindex].aktcas;
              peskycelkem := zasobnik[zasindex].pesky;
              zasindex := zasindex - 1;
             for i := 1 to N do
             begin
              if (aktcas <= stop) AND (i <> aktzastavka) AND ((aktlinka < L+1) <= existspoj(aktlinka,aktzastavka,i)) then
                 begin
                 dozasob(zasindex,i,aktlinka,aktcas,aktzastavka,peskycelkem);
                 end;
              if (aktcas <= stop) AND (i <> aktzastavka) then
                 begin
                 dozasob2(zasindex,i,aktlinka,aktcas,aktzastavka,peskycelkem);
                 end;
             end;
         end;
   until zasindex = 0;
   (*konec druhe casti*)
   ulozcil := cil;
   ulozmaxpesky := maxpesky;
   dobajizdy := stop - casnast;

   (*treti cast - nalezeni cesty, kdyz uz znam stop*)
if stop < maxint then
begin
   treticast := TRUE;
o := 0;
while cil <> start do
begin
   inicializace2;
   aktcas := 0;
   aktlinka := 0;
   zasindex := 0;
   dozasob(zasindex,start,aktlinka,casnast,start,0);
   dozasob2(zasindex,start,aktlinka,casnast,start,0);
   repeat
         begin
              aktzastavka := zasobnik[zasindex].cislozast;
              aktlinka := zasobnik[zasindex].cislolinky;
              aktcas := zasobnik[zasindex].aktcas;
              peskycelkem := zasobnik[zasindex].pesky;
              zasindex := zasindex - 1;
             for i := 1 to N do
             begin
              if (aktcas <= stop) AND (i <> aktzastavka) AND ((aktlinka < L+1) <= existspoj(aktlinka,aktzastavka,i)) then
                 begin
                 dozasob(zasindex,i,aktlinka,aktcas,aktzastavka,peskycelkem);
                 if konec then Break;
                 end;
              if (aktcas <= stop) AND (i <> aktzastavka) then
                 begin
                 dozasob2(zasindex,i,aktlinka,aktcas,aktzastavka,peskycelkem);
                 if konec then Break;
                 end;
             end;
             if konec then Break;
         end;
   until zasindex = 0;

       o := o + 1;
       cesta[o,1] := zpetnychod[cil,posllinka,3];
       cesta[o,2] := cil;
       cesta[o,3] := zpetnychod[cil,posllinka,4]; (* odjezd *)
       cesta[o,4] := zpetnychod[cil,posllinka,5]; (* prijezd *)
       stop := zpetnychod[cil,posllinka,4];
       zast := cil;
       cil := zpetnychod[zast,posllinka,1];
       if posllinka = L+1 then maxpesky := maxpesky - pesky[zast,cil];
       posllinka := zpetnychod[zast,posllinka,2];
end;
   o := o + 1;
   cesta[o,2] := start;
   cesta[o,4] := casnast;
end;
   (*konec treti casti*)

   if stop < maxint then
      begin
      vypiscestu(o);
      vypiscestusoubor(o);
      end
      else cestaneni(Lo(WindMax)+1,Hi(Windmax)+1);
   if not ukoncit(Lo(WindMax)+1,Hi(Windmax)+1) then Goto zacatek;

   TextMode(OrigMode);
   writeln('Spoje MHD v 1.0');
   writeln('Pavel Novk  01/2001');
    for i := 10 downto 1 do
       begin
       delay(100);
       sound(i*100);
       if Keypressed then  Break;
       end;
    NoSound;
end.